你的位置:首页 > Java教程

[Java教程]使用nvm利器,管理node版本


node.js越来越热,应用的场景也越来越多。

但也因为是开源软件,所以具备大多数开源软件都存在的“版本问题”,版本发展很快,版本前后差异性大,老系统用新版本node跑不过,全局安装的第三方组件和node版本相关造成全局版本混乱。

nvm是解决这一问题的利器。

nvm是node版本管理工具,主要特点:

1.可安装多版本的node。

2.灵活切换当前的node版本。

3.以沙箱方式全局安装第三方组件到对应版本的node中。

4.通过.vnmrc文件,方便灵活地指定各应用系统所需的node版本进行运行。

可惜目前只支持linux,OS系统。

接下来,就见证一下它的能力。 

 

安装nvm

通过下面的命令可进行一步到位的安装,下面两种方式可二选一。

curl -o- https://raw.githubusercontent.com/creationix/nvm/v0.31.2/install.sh | bash

或者:

wget -qO- https://raw.githubusercontent.com/creationix/nvm/v0.31.2/install.sh | bash

 

安装完后,验证安装

command -v nvm

默认会在“/home/个人账户”目录下会生成.nvm的隐藏目录,所有的node会以沙箱的方式装到该目录下。

安装完成。

 

详细可参考官方:https://github.com/creationix/nvm 

 

安装多版本node

在命令行中运行命令,安装当前最新的稳定版。

nvm install stable

当前最新的稳定版是6.3.0。

 

运行命令,指明版本,安装早期的版本0.12.4。

nvm install 0.12.4

  

安装后,当前使用的node版本默认为最后一次安装的版本,在命令行中运行命令可查看当前版本。

nvm current

 

切换node版本

运行命令切换。

nvm use 6

 

显示所有安装的版本

运行命令,列出所有版本。

nvm ls

 

左边有箭头的代表当前使用中的版本。

 

安装全局组件 

非nvm管理的情况下,全局组件是安装到/usr/local/lib/node_modules下,然后通过软连接的方式把包中bin目录下的可执行文件链接到/usr/local/bin。不管用什么版本都装到这些目录下,多版本就没法玩了。

在nvm管理下,以沙箱的方式,全局组件会装到.nvm目录的当前版本node下,也就是装在nvm这个沙箱里,跟在指定版本的node下,当前有什么版本的node,就有对应的全局组件。这是nvm强大的地方,在多运行环境的管理和切换极为好用。

下面,运行命令在当前6.3.0的node版本下以全局的方式安装express生成器。

npm install -g express-generator

express -V

可以清楚的看到express生成器被安装到了当前版本的node目录下。

express默认用的是最新的版本,这里是4.13.4。

 

现在,切换到0.12.4版本 

nvm use 0

然后,全局安装express生成器3.0版。

npm install -g express-generator@3

也可以清楚的看到express生成器装到了0.12.4版node目录下,装完后express版本是3.0.0。

可以再将node版本切换到6,那么当前的express版本又会切换成对应的版本。

很方便,很强大。

 

使用.nvmrc文件运行

在服务器上很多时候会运行多个应用系统,每个应用系统使用的node版本是不一样的,老系统用0.12.x甚至0.10.x,新系统用了新特新所以用最新的node版本,都很实际很正常。 

为了让不同的应用系统使用各自所需的node版本运行,我们只需在各应用系统内的根目录里生成一个.nvmrc文件,在其内写一个版本号,利用nvm run <系统启动文件>的方式运行系统,即可完成要求。

做个实验。

建个demo的文件夹,在其下写一个app1.js文件,其内容为:

console.log(process.versions);

只有一行代码,把当前运行的node版本输出到控制台。

 

与app1.js同级,写一个.nvmrc文件,其中的版本号写“0”,目的是要在0.12.4版本下运行,可以用命令:

echo '0' > .nvmrc

 

我们将当前的node版本切至6,然后运行:

nvm use 6
nvm run app1.js

运行效果:

可以看到运行demo的node版本取决于.nvmrc中写的版本。

通过.nvmrc作为运行版本配置,用nvm run命令进行启动的方式可以方便的完成同一个服务器运行多个不同版本的应用系统,非常方便灵活。